"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runTasksQueue = exports.delay = exports.fsExistsSync = void 0;
const fs_1 = __importDefault(require("fs"));
exports.fsExistsSync = (way) => {
    try {
        fs_1.default.accessSync(way, fs_1.default.constants.W_OK);
    }
    catch (e) {
        return false;
    }
    return true;
};
function delay(ms = 200) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((res) => {
            setTimeout(() => res(), ms);
        });
    });
}
exports.delay = delay;
// 每10个一批
exports.runTasksQueue = function (fns, fnParams, limit = 10) {
    return __awaiter(this, void 0, void 0, function* () {
        let success = 0;
        let fail = 0;
        while (fnParams.length > 0) {
            const runParams = fnParams.splice(0, limit);
            yield Promise.all(runParams.map((param, i) => __awaiter(this, void 0, void 0, function* () {
                try {
                    yield fns[i](param);
                    success++;
                }
                catch (_a) {
                    fail++;
                }
            })));
        }
        return {
            success,
            fail,
        };
    });
};
//# sourceMappingURL=util.js.map